// File 05mnl-beta.mod

[ModelDescription]
"Telephone 4-6"

[Choice]
choice

[Beta]
// Name Value  LowerBound UpperBound  status (0=variable, 1=fixed)
// starting values: 
//	asc1-4 and lcost at MNL estimates
//	non constrained sigmas at 1
ASC1	      -2.5         -10000         10000       0
ASC2	      -1.7         -10000         10000       0
ASC3	      -0.5         -10000         10000       0
ASC4	      -0.7         -10000         10000       0
LCOST		-2.0         -10000         10000       0
NEST1B	 0.0         -10000         10000       1
NEST2B       0.0         -10000         10000       1
NEST3B       0.0         -10000         10000       1
NEST4B       0.0         -10000         10000       1
NEST5B       0.0         -10000         10000       1
NEST6B       0.0         -10000         10000       1
NEST1S       1.0	       -10000         10000       0
NEST2S       1.0	       -10000         10000       0
NEST3S       1.0	       -10000         10000       0
NEST4S       1.0	       -10000         10000       0
NEST5S       1.0	       -10000         10000       0
NEST6S       1.0	       -10000         10000       0


[Utilities]
// Id Name  Avail  linear-in-parameter expression (beta1*x1 + beta2*x2 + ... )
  1   Alt1   av1   ASC1 * one + LCOST * lcost1 + NEST1B [ NEST1S ] * one + NEST2B [ NEST2S ] * one  
  2   Alt2   av2   ASC2 * one + LCOST * lcost2 + NEST2B [ NEST2S ] * one + NEST3B [ NEST3S ] * one 
  3   Alt3   av3   ASC3 * one + LCOST * lcost3 + NEST3B [ NEST3S ] * one + NEST4B [ NEST4S ] * one
  4	Alt4   av4   ASC4 * one + LCOST * lcost4 + NEST4B [ NEST4S ] * one + NEST5B [ NEST5S ] * one 
  5   Alt5   av5                LCOST * lcost5 + NEST5B [ NEST5S ] * one + NEST6B [ NEST6S ] * one 

[LinearConstraints]
NEST1S - NEST2S = 0
NEST2S - NEST3S = 0
NEST3S - NEST4S = 0
NEST4S - NEST5S = 0
NEST5S - NEST6S = 0

[Expressions] 
// Define here arithmetic expressions for name that are not directly 
// available from the data
one = 1

[Draws]
2000

[Model]
// Currently, only $MNL (multinomial logit), $NL (nested logit), $CNL
// (cross-nested logit) and $NGEV (Network GEV model) are valid keywords
//
$MNL
